# coding: utf-8

from __future__ import absolute_import
from datetime import date, datetime  # noqa: F401

from typing import List, Dict  # noqa: F401

from swagger_server.models.base_model_ import Model
from swagger_server import util


class RuntimeParameters(Model):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    def __init__(self, oxygen_percent: int=None, respirations_per_minute: int=None, tank_max_pressure: int=None, tank_min_pressure: int=None, lungs_min_pressure: int=None, lungs_max_pressure: int=None, lungs_critical_pressure: int=None, operations_mode: str=None, inspiration_time_percent: int=None, expiration_time_percent: int=None, pressure_unit: str=None, temperature_unit: str=None):  # noqa: E501
        """RuntimeParameters - a model defined in Swagger

        :param oxygen_percent: The oxygen_percent of this RuntimeParameters.  # noqa: E501
        :type oxygen_percent: int
        :param respirations_per_minute: The respirations_per_minute of this RuntimeParameters.  # noqa: E501
        :type respirations_per_minute: int
        :param tank_max_pressure: The tank_max_pressure of this RuntimeParameters.  # noqa: E501
        :type tank_max_pressure: int
        :param tank_min_pressure: The tank_min_pressure of this RuntimeParameters.  # noqa: E501
        :type tank_min_pressure: int
        :param lungs_min_pressure: The lungs_min_pressure of this RuntimeParameters.  # noqa: E501
        :type lungs_min_pressure: int
        :param lungs_max_pressure: The lungs_max_pressure of this RuntimeParameters.  # noqa: E501
        :type lungs_max_pressure: int
        :param lungs_critical_pressure: The lungs_critical_pressure of this RuntimeParameters.  # noqa: E501
        :type lungs_critical_pressure: int
        :param operations_mode: The operations_mode of this RuntimeParameters.  # noqa: E501
        :type operations_mode: str
        :param inspiration_time_percent: The inspiration_time_percent of this RuntimeParameters.  # noqa: E501
        :type inspiration_time_percent: int
        :param expiration_time_percent: The expiration_time_percent of this RuntimeParameters.  # noqa: E501
        :type expiration_time_percent: int
        :param pressure_unit: The pressure_unit of this RuntimeParameters.  # noqa: E501
        :type pressure_unit: str
        :param temperature_unit: The temperature_unit of this RuntimeParameters.  # noqa: E501
        :type temperature_unit: str
        """
        self.swagger_types = {
            'oxygen_percent': int,
            'respirations_per_minute': int,
            'tank_max_pressure': int,
            'tank_min_pressure': int,
            'lungs_min_pressure': int,
            'lungs_max_pressure': int,
            'lungs_critical_pressure': int,
            'operations_mode': str,
            'inspiration_time_percent': int,
            'expiration_time_percent': int,
            'pressure_unit': str,
            'temperature_unit': str
        }

        self.attribute_map = {
            'oxygen_percent': 'oxygenPercent',
            'respirations_per_minute': 'respirationsPerMinute',
            'tank_max_pressure': 'tankMaxPressure',
            'tank_min_pressure': 'tankMinPressure',
            'lungs_min_pressure': 'lungsMinPressure',
            'lungs_max_pressure': 'lungsMaxPressure',
            'lungs_critical_pressure': 'lungsCriticalPressure',
            'operations_mode': 'operationsMode',
            'inspiration_time_percent': 'inspirationTimePercent',
            'expiration_time_percent': 'expirationTimePercent',
            'pressure_unit': 'pressureUnit',
            'temperature_unit': 'temperatureUnit'
        }
        self._oxygen_percent = oxygen_percent
        self._respirations_per_minute = respirations_per_minute
        self._tank_max_pressure = tank_max_pressure
        self._tank_min_pressure = tank_min_pressure
        self._lungs_min_pressure = lungs_min_pressure
        self._lungs_max_pressure = lungs_max_pressure
        self._lungs_critical_pressure = lungs_critical_pressure
        self._operations_mode = operations_mode
        self._inspiration_time_percent = inspiration_time_percent
        self._expiration_time_percent = expiration_time_percent
        self._pressure_unit = pressure_unit
        self._temperature_unit = temperature_unit

    @classmethod
    def from_dict(cls, dikt) -> 'RuntimeParameters':
        """Returns the dict as a model

        :param dikt: A dict.
        :type: dict
        :return: The runtimeParameters of this RuntimeParameters.  # noqa: E501
        :rtype: RuntimeParameters
        """
        return util.deserialize_model(dikt, cls)

    @property
    def oxygen_percent(self) -> int:
        """Gets the oxygen_percent of this RuntimeParameters.

        percentage of oxygen allowed to flow inside the tank, when oxygen and air are mixed. Allowed values: 0-100  # noqa: E501

        :return: The oxygen_percent of this RuntimeParameters.
        :rtype: int
        """
        return self._oxygen_percent

    @oxygen_percent.setter
    def oxygen_percent(self, oxygen_percent: int):
        """Sets the oxygen_percent of this RuntimeParameters.

        percentage of oxygen allowed to flow inside the tank, when oxygen and air are mixed. Allowed values: 0-100  # noqa: E501

        :param oxygen_percent: The oxygen_percent of this RuntimeParameters.
        :type oxygen_percent: int
        """

        self._oxygen_percent = oxygen_percent

    @property
    def respirations_per_minute(self) -> int:
        """Gets the respirations_per_minute of this RuntimeParameters.

        frequency at which the patient breaths, in breathing cycles per minute. Allowed values: 6-17  # noqa: E501

        :return: The respirations_per_minute of this RuntimeParameters.
        :rtype: int
        """
        return self._respirations_per_minute

    @respirations_per_minute.setter
    def respirations_per_minute(self, respirations_per_minute: int):
        """Sets the respirations_per_minute of this RuntimeParameters.

        frequency at which the patient breaths, in breathing cycles per minute. Allowed values: 6-17  # noqa: E501

        :param respirations_per_minute: The respirations_per_minute of this RuntimeParameters.
        :type respirations_per_minute: int
        """

        self._respirations_per_minute = respirations_per_minute

    @property
    def tank_max_pressure(self) -> int:
        """Gets the tank_max_pressure of this RuntimeParameters.

        Upper end of the pressure range in the tank. If the pressure is higher than the limit, the compressor turns off.  Allowed values: 0-14500  # noqa: E501

        :return: The tank_max_pressure of this RuntimeParameters.
        :rtype: int
        """
        return self._tank_max_pressure

    @tank_max_pressure.setter
    def tank_max_pressure(self, tank_max_pressure: int):
        """Sets the tank_max_pressure of this RuntimeParameters.

        Upper end of the pressure range in the tank. If the pressure is higher than the limit, the compressor turns off.  Allowed values: 0-14500  # noqa: E501

        :param tank_max_pressure: The tank_max_pressure of this RuntimeParameters.
        :type tank_max_pressure: int
        """

        self._tank_max_pressure = tank_max_pressure

    @property
    def tank_min_pressure(self) -> int:
        """Gets the tank_min_pressure of this RuntimeParameters.

        Lower end of pressure range in the tank. If the pressure is lower than the limit, the compressor turns on to refill the tank. Allowed values: 0-14500  # noqa: E501

        :return: The tank_min_pressure of this RuntimeParameters.
        :rtype: int
        """
        return self._tank_min_pressure

    @tank_min_pressure.setter
    def tank_min_pressure(self, tank_min_pressure: int):
        """Sets the tank_min_pressure of this RuntimeParameters.

        Lower end of pressure range in the tank. If the pressure is lower than the limit, the compressor turns on to refill the tank. Allowed values: 0-14500  # noqa: E501

        :param tank_min_pressure: The tank_min_pressure of this RuntimeParameters.
        :type tank_min_pressure: int
        """

        self._tank_min_pressure = tank_min_pressure

    @property
    def lungs_min_pressure(self) -> int:
        """Gets the lungs_min_pressure of this RuntimeParameters.

        Lower end of lung pressure range If the pressure is lower than the limit, the inspiration valve turns on after each period passes. Allowed values: 0-1600  # noqa: E501

        :return: The lungs_min_pressure of this RuntimeParameters.
        :rtype: int
        """
        return self._lungs_min_pressure

    @lungs_min_pressure.setter
    def lungs_min_pressure(self, lungs_min_pressure: int):
        """Sets the lungs_min_pressure of this RuntimeParameters.

        Lower end of lung pressure range If the pressure is lower than the limit, the inspiration valve turns on after each period passes. Allowed values: 0-1600  # noqa: E501

        :param lungs_min_pressure: The lungs_min_pressure of this RuntimeParameters.
        :type lungs_min_pressure: int
        """

        self._lungs_min_pressure = lungs_min_pressure

    @property
    def lungs_max_pressure(self) -> int:
        """Gets the lungs_max_pressure of this RuntimeParameters.

        Upper end of lung pressure range. If the pressure is higher than the limit, the inspiration valve turns off after each period passes. Allowed values: 0-1600  # noqa: E501

        :return: The lungs_max_pressure of this RuntimeParameters.
        :rtype: int
        """
        return self._lungs_max_pressure

    @lungs_max_pressure.setter
    def lungs_max_pressure(self, lungs_max_pressure: int):
        """Sets the lungs_max_pressure of this RuntimeParameters.

        Upper end of lung pressure range. If the pressure is higher than the limit, the inspiration valve turns off after each period passes. Allowed values: 0-1600  # noqa: E501

        :param lungs_max_pressure: The lungs_max_pressure of this RuntimeParameters.
        :type lungs_max_pressure: int
        """

        self._lungs_max_pressure = lungs_max_pressure

    @property
    def lungs_critical_pressure(self) -> int:
        """Gets the lungs_critical_pressure of this RuntimeParameters.

        Warning level for pressure in the lungs. Allowed values: 0-1600  # noqa: E501

        :return: The lungs_critical_pressure of this RuntimeParameters.
        :rtype: int
        """
        return self._lungs_critical_pressure

    @lungs_critical_pressure.setter
    def lungs_critical_pressure(self, lungs_critical_pressure: int):
        """Sets the lungs_critical_pressure of this RuntimeParameters.

        Warning level for pressure in the lungs. Allowed values: 0-1600  # noqa: E501

        :param lungs_critical_pressure: The lungs_critical_pressure of this RuntimeParameters.
        :type lungs_critical_pressure: int
        """

        self._lungs_critical_pressure = lungs_critical_pressure

    @property
    def operations_mode(self) -> str:
        """Gets the operations_mode of this RuntimeParameters.

        Operational Mode, one of \"pressure\", \"time\", \"interactive\".   # noqa: E501

        :return: The operations_mode of this RuntimeParameters.
        :rtype: str
        """
        return self._operations_mode

    @operations_mode.setter
    def operations_mode(self, operations_mode: str):
        """Sets the operations_mode of this RuntimeParameters.

        Operational Mode, one of \"pressure\", \"time\", \"interactive\".   # noqa: E501

        :param operations_mode: The operations_mode of this RuntimeParameters.
        :type operations_mode: str
        """

        self._operations_mode = operations_mode

    @property
    def inspiration_time_percent(self) -> int:
        """Gets the inspiration_time_percent of this RuntimeParameters.

        percentage of time that inspiration takes relative to the length of the  breathing period. Range: 25-75  # noqa: E501

        :return: The inspiration_time_percent of this RuntimeParameters.
        :rtype: int
        """
        return self._inspiration_time_percent

    @inspiration_time_percent.setter
    def inspiration_time_percent(self, inspiration_time_percent: int):
        """Sets the inspiration_time_percent of this RuntimeParameters.

        percentage of time that inspiration takes relative to the length of the  breathing period. Range: 25-75  # noqa: E501

        :param inspiration_time_percent: The inspiration_time_percent of this RuntimeParameters.
        :type inspiration_time_percent: int
        """

        self._inspiration_time_percent = inspiration_time_percent

    @property
    def expiration_time_percent(self) -> int:
        """Gets the expiration_time_percent of this RuntimeParameters.

        percentage of time that expiration takes relative to the length of the  breathing period. Allowed range: 25-75  # noqa: E501

        :return: The expiration_time_percent of this RuntimeParameters.
        :rtype: int
        """
        return self._expiration_time_percent

    @expiration_time_percent.setter
    def expiration_time_percent(self, expiration_time_percent: int):
        """Sets the expiration_time_percent of this RuntimeParameters.

        percentage of time that expiration takes relative to the length of the  breathing period. Allowed range: 25-75  # noqa: E501

        :param expiration_time_percent: The expiration_time_percent of this RuntimeParameters.
        :type expiration_time_percent: int
        """

        self._expiration_time_percent = expiration_time_percent

    @property
    def pressure_unit(self) -> str:
        """Gets the pressure_unit of this RuntimeParameters.

        One of \"mpsi\", \"pa\", \"cmh2o\", \"mmhg\", \"mbar\"  # noqa: E501

        :return: The pressure_unit of this RuntimeParameters.
        :rtype: str
        """
        return self._pressure_unit

    @pressure_unit.setter
    def pressure_unit(self, pressure_unit: str):
        """Sets the pressure_unit of this RuntimeParameters.

        One of \"mpsi\", \"pa\", \"cmh2o\", \"mmhg\", \"mbar\"  # noqa: E501

        :param pressure_unit: The pressure_unit of this RuntimeParameters.
        :type pressure_unit: str
        """

        self._pressure_unit = pressure_unit

    @property
    def temperature_unit(self) -> str:
        """Gets the temperature_unit of this RuntimeParameters.

        One of \"celsius\", \"farenheit\"  # noqa: E501

        :return: The temperature_unit of this RuntimeParameters.
        :rtype: str
        """
        return self._temperature_unit

    @temperature_unit.setter
    def temperature_unit(self, temperature_unit: str):
        """Sets the temperature_unit of this RuntimeParameters.

        One of \"celsius\", \"farenheit\"  # noqa: E501

        :param temperature_unit: The temperature_unit of this RuntimeParameters.
        :type temperature_unit: str
        """

        self._temperature_unit = temperature_unit
